import * as api from './api.js';
import Status from './status.js';
class User {
    constructor(ff, user) {
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "screenName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "uniqueId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "location", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "gender", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "birthday", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "description", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileImageUrl", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileImageUrlLarge", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "url", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "protected", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "followersCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "friendsCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "favouritesCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "statusesCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "photoCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "following", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "notifications", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "createdAt", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "utcOffset", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileImageOrigin", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileImageOriginLarge", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileBackgroundColor", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileTextColor", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileLinkColor", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileSidebarFillColor", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileSidebarBorderColor", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileBackgroundImageUrl", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "profileBackgroundTile", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "status", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "ff", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "follow", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.createFriendship(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "unfollow", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.dropFriendship(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "block", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.createBlockedUser(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "unblock", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.dropBlockedUser(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "checkBlock", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.checkBlockExists(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "tags", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getUserTags(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "show", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getUser(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "timeline", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getUserTimeline(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "searchTimeline", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.searchUserTimeline(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "recentFollowers", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getRecentFollowers(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "followers", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getFollowers(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "followerIds", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getFollowerIds(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "followings", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getFollowings(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "followingIds", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.getFollowingIds(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "acceptFriendship", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.acceptFriendship(this.ff, {
                id: this.id,
                ...options
            })
        });
        Object.defineProperty(this, "denyFriendship", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: async (options) => api.denyFriendship(this.ff, {
                id: this.id,
                ...options
            })
        });
        this.ff = ff;
        this.id = user.id;
        this.name = user.name;
        this.screenName = user.screenName;
        this.uniqueId = user.uniqueId;
        this.location = user.location;
        this.gender = user.gender;
        this.birthday = user.birthday;
        this.description = user.description;
        this.profileImageUrl = user.profileImageUrl;
        this.profileImageUrlLarge = user.profileImageUrlLarge;
        this.url = user.url;
        this.protected = user.protected;
        this.followersCount = user.followersCount;
        this.friendsCount = user.friendsCount;
        this.favouritesCount = user.favouritesCount;
        this.statusesCount = user.statusesCount;
        this.photoCount = user.photoCount;
        this.following = user.following;
        this.notifications = user.notifications;
        this.createdAt = user.createdAt;
        this.utcOffset = user.utcOffset;
        this.profileBackgroundColor = user.profileBackgroundColor;
        this.profileTextColor = user.profileTextColor;
        this.profileLinkColor = user.profileLinkColor;
        this.profileSidebarFillColor = user.profileSidebarFillColor;
        this.profileSidebarBorderColor = user.profileSidebarBorderColor;
        this.profileBackgroundImageUrl = user.profileBackgroundImageUrl;
        this.profileBackgroundTile = user.profileBackgroundTile;
        this.profileImageOrigin = this.profileImageUrl.replace(/\?\d{10}/, '');
        this.profileImageOriginLarge = this.profileImageUrlLarge.replace(/\?\d{10}/, '');
        if (user.status) {
            this.status =
                user.status instanceof Status
                    ? user.status
                    : new Status(ff, user.status);
        }
    }
}
export default User;
